#!/bin/sh
export DIRNAME="`busybox dirname "$0"`"
export FLM="`busybox basename "$2"`"
export DIRFILE="`busybox dirname "$2"`"
export URL="$2"
export FILENAME="`echo ${FLM%.*}`"
export EXTFILE="`echo ${FLM##*.}`"
info(){
	cd "$DIRNAME"
	./7z l "$URL" > /tmp/archive
	LIST=`sed -e 1,/^$/d /tmp/archive | sed /----/d | sed /^$/d |sed '/Listing/,/Date/d'| sed '$d' | awk '{print $NF "\nSize:"$4 "bytes"}'`
	INFO=`sed -e 1,/^$/d /tmp/archive | sed /----/d | sed /^$/d | sed -n '/Path/,/Date/p' | sed '$d'`
	INFO2=`sed -e 1,/^$/d /tmp/archive | sed /----/d | sed /^$/d | sed '$!d' | awk '{print "Size = "$1 "b\n" $3" files, "$5 " folders" }'`
	showMsg "Информация об архиве" "$INFO $INFO2$IFS--------$IFS$LIST" 2
	main
}
main(){
	showRadio "P7Zip" "$URL
Выберите действие:" "Смотреть информацию" "Извлечь в ..." "Извлечь сюда" "Извлечь сюда <имя архива>"
case "$?" in
	"1")info;;
	"2")
	cd "$DIRFILE"/
	exec "$DIRNAME"/fmunpack.csh;;
	"3")
	cd "$DIRFILE"/
	if [ "$EXTFILE" = "tgz" ] || [ "$EXTFILE" = "TGZ" ] || [ "$EXTFILE" = "tbz2" ] || [ "$EXTFILE" = "TBZ2" ]
		then
		"$DIRNAME"/7z e "$URL" > /tmp/archive
		export FILENAME="`cat /tmp/archive | grep Extracting | awk '{print $2}'`"
		"$DIRNAME"/7z x "`pwd`"/"$FILENAME" -aou
		rm "`pwd`"/"$FILENAME"
	else
		"$DIRNAME"/7z x "$URL" -aou
	fi
	showMsg "Информация" "Распаковка завершена" 2
	;;
	"4")
	cd "$DIRFILE"/
	mkdir "$FILENAME"
	cd "$FILENAME"/
	if [ "$EXTFILE" = "tgz" ] || [ "$EXTFILE" = "TGZ" ] || [ "$EXTFILE" = "tbz2" ] || [ "$EXTFILE" = "TBZ2" ]
		then
		"$DIRNAME"/7z e "$URL" > /tmp/archive
		export FILENAME="`cat /tmp/archive | grep Extracting | awk '{print $2}'`"
		"$DIRNAME"/7z x "`pwd`"/"$FILENAME" -aou
		rm "`pwd`"/"$FILENAME"
	else
		"$DIRNAME"/7z x "$URL" -aou
	fi
	showMsg "Информация" "Распаковка завершена" 2
	;;
	esac
}
if [ "$2" != "" ]
then
main
else
showRadio "P7Zip" "Выберите действие:" "Раcпаковать файлы" "Упаковать файлы"
case "$?" in
	"1")exec "$DIRNAME"/arcfind.csh;;
	"2")exec "$DIRNAME"/arcpack.csh;;
esac
fi
exit