#!/bin/sh
#efm
export DIRNAME="`busybox dirname "$0"`"
export FILENAME=""
addtoarc()
{
export CURFOLDER=`pwd`
LS=`ls -a | sed -e "/^\.$/d" | sed -e "/^\..$/d" |sed s/\ /~/g`
showRadio "P7Zip" "Выберите архив:" "../" $LS
RADIORES=$?
 if [ $RADIORES -eq 0 ]
 	then
		onefile
elif [ $RADIORES -eq 1 ]
	then
		cd ../
		addtoarc
else
	let n=$RADIORES-1
	CD=`ls -a | sed -e "/^\.$/d" | sed -e "/^\..$/d" | sed -n $n\p`
	if [ -d "$CD" ]
		then
			cd "$CD"
			addtoarc
		else
			ARCNAME="$CURFOLDER/$CD"
			"$DIRNAME"/7z a "$ARCNAME" "$FILENAME"
	fi
fi
}
multiadd()
{
LS=`ls -a | sed -e "/^\.$/d" | sed -e "/^\..$/d" |sed s/\ /~/g | awk '{print $NF " 0"}'` 
showMultiSelect "/tmp/multiselect" "P7Zip" "Выбор" $LS
SEL=$?
if [ $SEL -eq 0 ]
then
	refresh
else
for ID in `cat /tmp/multiselect`
 do
	TEMPNAME=`ls -a | sed -e "/^\.$/d" | sed -e "/^\..$/d" | sed -n $ID\p`
	FILENAME=`echo -n "$FILENAME" "$CURFOLDER"/"$TEMPNAME"`
done
showRadio "P7Zip" "Формат архива:" "7z" "Zip" "Tgz"
case "$?" in
	"0")refresh;;
	"1")"$DIRNAME"/7z a "$ARCNAME" $FILENAME;;
	"2")"$DIRNAME"/7z a -tzip "$ARCNAME" $FILENAME;;
	"3")busybox tar cvf "$ARCNAME".tar $FILENAME
		busybox gzip "$ARCNAME".tar;;
esac
fi
showMsg "Информация" "Архивирование завершено" 2
}
addnew()
{
showRadio "P7Zip" "Выберите действие:" "Добавить в архив (zip/7z)" "Создать архив"
case "$?" in
	"0")refresh;;
	"1")addtoarc;;
	"2")showRadio "P7Zip" "Формат архива:" "7z" "Zip" "Tgz"
		case "$?" in
			"0")refresh;;
			"1")"$DIRNAME"/7z a "$ARCNAME" "$FILENAME";;
			"2")"$DIRNAME"/7z a -tzip "$ARCNAME" "$FILENAME";;
			"3")busybox tar cvf "$ARCNAME".tar "$FILENAME"
				busybox gzip "$ARCNAME".tar;;
		esac;;
		
esac
showMsg "Информация" "Архивирование завершено" 2

}
refresh()
{
export CURFOLDER=`pwd`
export ARCNAME=`busybox basename "$CURFOLDER"`
export URLDIR="$CURFOLDER/$ARCNAME"
LS=`ls -a | sed -e "/^\.$/d" | sed -e "/^\..$/d" |sed s/\ /~/g`
showRadio "P7Zip" "Выберите папку/файл:$IFS`pwd`" "Выбрать текущую папку" "Выбрать несколько папок/файлов" "../" $LS
RADIORES=$?
if [ $RADIORES -eq 0 ]
	then
		exit 0
elif [ $RADIORES -eq 1 ]
	then
		FILENAME="$CURFOLDER"
		addnew
elif [ $RADIORES -eq 2 ]
	then
		multiadd
elif [ $RADIORES -eq 3 ]
	then
		cd ../
		refresh
else
	let n=$RADIORES-3
	CD=`ls -a | sed -e "/^\.$/d" | sed -e "/^\..$/d" | sed -n $n\p`
	if [ -d "$CD" ]
		then
			cd "$CD"
			refresh
		else
			FILENAME="$CURFOLDER/$CD"
			ARCNAME="`echo ${CD%.*}`"
			addnew
	fi
fi
}
cd /mmc/mmca1/
refresh